Free-vortex models for wind turbine wakes under yaw
misalignment –- a validation study on far-wake effects
===============================================================================
Authors: Maarten J. van den Broek
Delft Centre for Systems and Control, Delft University of Technology
Mekelweg 2, 2682CD Delft, Netherlands
m.j.vandenbroek@tudelft.nl

General introduction
--------------------
The dataset contains code and simulation results for a validation study comparing three free-vortex wake models for wind turbine control optimisation.
The experimental data supporting this work is made public separately.
The dataset is being made public as supplementary material supporting the paper "Free-vortex models for wind turbine wakes under yaw
misalignment – a validation study on far-wake effects". 

This work is part of the research programme 'Robust closed-loop wake steering for large densely spaced wind farms' with project number 17512, which is (partly) financed by the Dutch Research Council (NWO).

Methodological information
--------------------------
Methodology for generating the data is presented in the associated paper at __DOI__.
The code for the model and scripts for running the experiments are included in the `code` directory.
The simulations were performed in an environment with Julia 1.8.0.

	validationscripts/ - scripts used to generate the data for the paper
		`setup.jl`			- initialisation of modules
		`mowitobase.jl` 	- basic set-up functions for simulations
		`generateslice.jl`	- generation of flow slices
		`dynamicojf.jl` 	- replication of WTB experiment
		`dynamictest.jl` 	- replication of WTC experiment
	VortexWake	- module with model code for simulation of the ADM, ADMR, and ALM wake models

Data Files
-----
The `data` directory contains the model data used in the associated paper.
 - `flow slices/` simulated flow fields, slices at hub height and at x/D = 1,2,3,4,5,6,7
 - `wake_deflection_` cross-stream positions of minimum potential power
 - `power_estimate_WTB_` aerodynamic power estimates for replication of WTB
 - `power_estimate_WTC_` aerodynamic and generator power estimates for replication of WTC


Column names
------------
	x,y,z 			- spatial coordinates (normalised by rotor diameter)
	u,v,w 			- velocity components (normalised by free-stream velocity and rotor diameter)
	power_aero_ 	- aerodynamic available power (Watt)
	power_generator - generator power estimate (Watt)
	simulation_time - non-dimensionalised simulation time (by rotor diameter and free-stream)
	wind_tunnel_time - actual time in wind tunnel
	yaw - wind turbine yaw angle (degrees)


Licence
-------
