export plot_points

function plot_points(wake::ADMWake)
    colors = (:darkblue, :lightblue, :blue)
    X = wake.states.positions

    traces = GenericTrace[]
    for r in 1:1:wake.parameters.num_rings
        XR = X[(0:end).%end.+1,r]
        push!(traces,
        # PlotlyJS.scatter(x=X[r,2*b-1:2*b,1], y=X[r,2*b-1:2*b,2], z=X[r,2*b-1:2*b,3],
        PlotlyJS.scatter(x=[p[1] for p in XR], y=[p[2] for p in XR], z=[p[3] for p in XR],
        type="scatter3d",
        line=attr(color=colors[1], width=2,alpha=0.3),
        # aspect_ratio=:equal,
        mode="lines"))
        push!(traces,
        # PlotlyJS.scatter(x=X[r,2*b-1:2*b,1], y=X[r,2*b-1:2*b,2], z=X[r,2*b-1:2*b,3],
        PlotlyJS.scatter(x=[p[1] for p in XR], y=[p[2] for p in XR], z=[p[3] for p in XR],
        type="scatter3d",
        marker_color=colors[1],
        mode="markers",
        marker_size=2,legend=false))
    end

    pl =PlotlyJS.plot(traces, Layout(scene_xaxis_range=[-1.,10.],
    scene_yaxis_range=(-2.,2.),scene_zaxis_range=(-1.,4.),
        scene_aspectratio=attr(x=11, y=4, z=5),
        showlegend=false))
    # Plot([pltscatter],layout)
end


function plot_points(wake1::ADMWake, wake2::ADMWake)
    colors = (:darkblue, :darkorange, :blue)
    wake = wake1
    X = wake.states.positions
    traces = GenericTrace[]
    for r in 1:1:wake.parameters.num_rings
        XR = X[(0:end).%end.+1,r]
        push!(traces,
        # PlotlyJS.scatter(x=X[r,2*b-1:2*b,1], y=X[r,2*b-1:2*b,2], z=X[r,2*b-1:2*b,3],
        PlotlyJS.scatter(x=[p[1] for p in XR], y=[p[2] for p in XR], z=[p[3] for p in XR],
        type="scatter3d",
        line=attr(color=colors[1], width=2,alpha=0.3),
        # aspect_ratio=:equal,
        mode="lines"))
        push!(traces,
        # PlotlyJS.scatter(x=X[r,2*b-1:2*b,1], y=X[r,2*b-1:2*b,2], z=X[r,2*b-1:2*b,3],
        PlotlyJS.scatter(x=[p[1] for p in XR], y=[p[2] for p in XR], z=[p[3] for p in XR],
        type="scatter3d",
        marker_color=colors[1],
        mode="markers",
        marker_size=2,legend=false))
    end
    wake = wake2
    X = wake.states.positions
    # traces = GenericTrace[]
    for r in 1:1:wake.parameters.num_rings
        XR = X[(0:end).%end.+1,r]
        push!(traces,
        # PlotlyJS.scatter(x=X[r,2*b-1:2*b,1], y=X[r,2*b-1:2*b,2], z=X[r,2*b-1:2*b,3],
        PlotlyJS.scatter(x=[p[1] for p in XR], y=[p[2] for p in XR], z=[p[3] for p in XR],
        type="scatter3d",
        line=attr(color=colors[2], width=2,alpha=0.3),
        # aspect_ratio=:equal,
        mode="lines"))
        push!(traces,
        # PlotlyJS.scatter(x=X[r,2*b-1:2*b,1], y=X[r,2*b-1:2*b,2], z=X[r,2*b-1:2*b,3],
        PlotlyJS.scatter(x=[p[1] for p in XR], y=[p[2] for p in XR], z=[p[3] for p in XR],
        type="scatter3d",
        marker_color=colors[2],
        mode="markers",
        marker_size=2,legend=false))
    end

    pl =PlotlyJS.plot(traces, Layout(scene_xaxis_range=[-1.,19.],
    scene_yaxis_range=(-2.,2.),scene_zaxis_range=(-1.,1.),
        scene_aspectratio=attr(x=20, y=4, z=2),
        showlegend=false))
    # Plot([pltscatter],layout)
end


function plot_points(wake::ADMRWake)
    colors = (:darkblue, :lightblue, :blue)
    X = wake.states.positions ./ wake.parameters.rotor.parameters.diameter

    traces = GenericTrace[]
    for r in 1:1:wake.parameters.num_rings
        XR = X[(0:wake.parameters.num_elements).%wake.parameters.num_elements.+1,r]
        push!(traces,
        # PlotlyJS.scatter(x=X[r,2*b-1:2*b,1], y=X[r,2*b-1:2*b,2], z=X[r,2*b-1:2*b,3],
        PlotlyJS.scatter(x=[p[1] for p in XR], y=[p[2] for p in XR], z=[p[3] for p in XR],
        type="scatter3d",
        line=attr(color=colors[1], width=2,alpha=0.3),
        # aspect_ratio=:equal,
        mode="lines"))
        push!(traces,
        # PlotlyJS.scatter(x=X[r,2*b-1:2*b,1], y=X[r,2*b-1:2*b,2], z=X[r,2*b-1:2*b,3],
        PlotlyJS.scatter(x=[p[1] for p in XR], y=[p[2] for p in XR], z=[p[3] for p in XR],
        type="scatter3d",
        marker_color=colors[1],
        mode="markers",
        marker_size=2,legend=false))
    end
    XR = X[end,:]
    push!(traces,
        # PlotlyJS.scatter(x=X[r,2*b-1:2*b,1], y=X[r,2*b-1:2*b,2], z=X[r,2*b-1:2*b,3],
        PlotlyJS.scatter(x=[p[1] for p in XR], y=[p[2] for p in XR], z=[p[3] for p in XR],
        type="scatter3d",
        line=attr(color=colors[1], width=2,alpha=0.3),
        # aspect_ratio=:equal,
        mode="lines"))
        push!(traces,
        # PlotlyJS.scatter(x=X[r,2*b-1:2*b,1], y=X[r,2*b-1:2*b,2], z=X[r,2*b-1:2*b,3],
        PlotlyJS.scatter(x=[p[1] for p in XR], y=[p[2] for p in XR], z=[p[3] for p in XR],
        type="scatter3d",
        marker_color=colors[1],
        mode="markers",
        marker_size=2,legend=false))

    pl =PlotlyJS.plot(traces, Layout(scene_xaxis_range=[-1.,10.],
    scene_yaxis_range=(-2.,2.),scene_zaxis_range=(-1.,3.),
        scene_aspectratio=attr(x=11, y=4, z=4),
        showlegend=false))
    # Plot([pltscatter],layout)
end

function plot_points(wake::JoukowskyWake)
    colors = (:darkblue, :lightblue, :blue, :black)
    X = wake.states.positions

    traces = GenericTrace[]
    # for r in 1:1:wake.parameters.num_rings
        for b in 1:1:wake.parameters.num_blades+1
            XR = X[b,:]
            push!(traces,
            # PlotlyJS.scatter(x=X[r,2*b-1:2*b,1], y=X[r,2*b-1:2*b,2], z=X[r,2*b-1:2*b,3],
            PlotlyJS.scatter(x=[p[1] for p in XR], y=[p[2] for p in XR], z=[p[3] for p in XR],
            type="scatter3d",
            line=attr(color=colors[b], width=3,alpha=0.3),
            # aspect_ratio=:equal,
            mode="lines"))
            push!(traces,
            # PlotlyJS.scatter(x=X[r,2*b-1:2*b,1], y=X[r,2*b-1:2*b,2], z=X[r,2*b-1:2*b,3],
            PlotlyJS.scatter(x=[p[1] for p in XR], y=[p[2] for p in XR], z=[p[3] for p in XR],
            type="scatter3d",
            marker_color=colors[b],
            mode="markers",
            marker_size=2,legend=false))
            XR = X[[4,b],1]
            push!(traces,
            # PlotlyJS.scatter(x=X[r,2*b-1:2*b,1], y=X[r,2*b-1:2*b,2], z=X[r,2*b-1:2*b,3],
            PlotlyJS.scatter(x=[p[1] for p in XR], y=[p[2] for p in XR], z=[p[3] for p in XR],
            type="scatter3d",
            line=attr(color=colors[b], width=10,alpha=0.3),
            # aspect_ratio=:equal,
            mode="lines"))
        end
    # end

    pl =PlotlyJS.plot(traces, Layout(scene_xaxis_range=[-1.,10.],
    scene_yaxis_range=(-2.,2.),scene_zaxis_range=(-1.,3.),
        scene_aspectratio=attr(x=11, y=4, z=3),
        showlegend=false))
    # Plot([pltscatter],layout)
end
# plot_points(wake)

function get_flow_data_xy(wake::Wake, zpos)
    D = wake.parameters.rotor.parameters.diameter
    x=-2*D:0.05*D:10*D
    # y=-200.:10.:200.
    y= -2*D:0.05*D:3*D #0.:10.:400.
    xg = repeat(reshape(x,1,:),length(y),1)
    yg = repeat(y,1,length(x))
    z = zpos
    v(x,y) =  vw.velocity([x y z],wake)
    uvec = map(v, xg, yg)
    uvec = mapreduce(permutedims,hcat,uvec)
    np = length(x)*length(y)
    data = [reshape(xg, np) reshape(yg, np) uvec'] #reshape(uvec, np) reshape(w, np)]
    cols = ["x", "y", "u", "v","w"]
    return DataFrame(data,cols)
end